function expe_errgt_geod_curvature_display
%EXPE_ERRGT_GEOD_CURVATURE_DISPLAY Displays the results generated with
%"expe_errgt_geod_curvature".
%
% (c)Florent Brunet

% RIS is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
% 
% RIS is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
% or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
% for more details.
% 
% You should have received a copy of the GNU General Public License along
% with this program; if not, write to the Free Software Foundation, Inc.,
% 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
close all;

EXPE_SURF_MIN = 1;
EXPE_SURF_MAX = 900;

all_err_r1 = [];
all_err_r2 = [];
all_err_s =  [];
all_err_p1 = [];
all_err_p2 = [];
all_err_b1 = [];
all_err_b2 = [];

all_err_gt_s =  [];
all_err_gt_b1 = [];
all_err_gt_b2 = [];

all_eucl = zeros(EXPE_SURF_MAX-EXPE_SURF_MIN+1, 10000);
all_geod_b1 = zeros(EXPE_SURF_MAX-EXPE_SURF_MIN+1, 10000);
all_geod_b2 = zeros(EXPE_SURF_MAX-EXPE_SURF_MIN+1, 10000);

all_curv_b1 = zeros(EXPE_SURF_MAX-EXPE_SURF_MIN+1, 10000);
all_curv_b2 = zeros(EXPE_SURF_MAX-EXPE_SURF_MIN+1, 10000);

for i_expe_surf = EXPE_SURF_MIN:EXPE_SURF_MAX
    disp(i_expe_surf);
    
    %path_paper = sprintf('data_paper_100/paper%04d.mat', i_expe_surf);
    %load(path_paper);
    
    path_res = sprintf('expe_errgt_geod_curvature/%04d.mat', i_expe_surf);
    load(path_res);
    
    %{
    all_err_r1 = [all_err_r1 err_r1];
    all_err_r2 = [all_err_r2 err_r2];
    all_err_s  = [all_err_s  err_s ];
    all_err_p1 = [all_err_p1 err_p1];
    all_err_p2 = [all_err_p2 err_p2];
    all_err_b1 = [all_err_b1 err_b1];
    all_err_b2 = [all_err_b2 err_b2];
    
    all_err_gt_s =  [all_err_gt_s  err_gt_s];
    all_err_gt_b1 = [all_err_gt_b1 err_gt_b1];
    all_err_gt_b2 = [all_err_gt_b2 err_gt_b2];
    %}
    
    all_eucl(i_expe_surf, :) = eucl;
    all_geod_b1(i_expe_surf, :) = geod_b1;
    all_geod_b2(i_expe_surf, :) = geod_b2;
    
    all_curv_b1(i_expe_surf, :) = curv_b1;
    all_curv_b2(i_expe_surf, :) = curv_b2;
end

%{
all_err = ...
    [all_err_r1(:) ...
    all_err_r2(:) ...
     all_err_s(:) ... 
    all_err_p1(:) ...
    all_err_p2(:) ...
    all_err_b1(:) ...
    all_err_b2(:)];

all_err_gt = ...
    [all_err_gt_s(:) ... 
    all_err_gt_b1(:) ...
    all_err_gt_b2(:)];

figure(1);
boxplot(all_err, 'labels', {'SOCP', 'SOCPvect', 'Salzmann', 'Perriollat', 'Perriollat', 'FFDinit', 'FFDrefined'}, 'labelorientation', 'inline')
set(gca, 'yscale', 'log', 'linewidth', 2, 'fontsize', 16, 'ytick', [0.5 1 2 5 10 50 100]);
ylabel('Errors w.r.t. the ground truth 3D positions (mm)');

figure(2);
boxplot(all_err_gt, 'labels', {'Salzmann', 'FFDinit', 'FFDrefined'}, 'labelorientation', 'inline')
set(gca, 'yscale', 'log', 'linewidth', 2, 'fontsize', 16, 'ytick', [0.5 1 2 5 10 50 100]);
ylabel('Error between the reconstructed surface and the ground truth one (mm)');
%}

all_eucl = vect(all_eucl');
all_geod_b1 = vect(all_geod_b1');
all_geod_b2 = vect(all_geod_b2');
all_curv_b1 = vect(all_curv_b1');
all_curv_b2 = vect(all_curv_b2');

rand('state', 1);
ind = randperm(numel(all_eucl));
ind = ind(1:100000);

all_eucl = all_eucl(ind);
all_geod_b1 = all_geod_b1(ind);
all_geod_b2 = all_geod_b2(ind);
all_curv_b1 = all_curv_b1(ind);
all_curv_b2 = all_curv_b2(ind);

plot(all_eucl, all_geod_b1, '.');
daspect([1 1 1]);
set(gca, 'xlim', [0 300], 'ylim', [0 300], 'linewidth', 2, 'fontsize', 16, 'xtick', 0:100:300, 'ytick', 0:100:300);
hold on;
plot([0 300], [0 300], 'r--', 'linewidth', 2);
%xlabel('Euclidean distance in the template image (mm)');
%ylabel('Length of the same path on the surface (mm)');


figure(4);
plot(all_eucl, all_geod_b2, '.');
daspect([1 1 1]);
set(gca, 'xlim', [0 300], 'ylim', [0 300], 'linewidth', 2, 'fontsize', 16, 'xtick', 0:100:300, 'ytick', 0:100:300);
hold on;
plot([0 300], [0 300], 'r--', 'linewidth', 2);
%xlabel('Euclidean distance in the template image (mm)');
%ylabel('Length of the same path on the surface (mm)');

figure(5);
plot(all_eucl, all_geod_b2, '.');
daspect([1 1 1]);
set(gca, 'xlim', [148.9 151.1], 'ylim', [148.9 151.1], 'linewidth', 2, 'fontsize', 16, 'xtick', 149:151, 'ytick', 149:151);
hold on;
plot([0 300], [0 300], 'r--', 'linewidth', 2);
%xlabel('Euclidean distance in the template image (mm)');
%ylabel('Length of the same path on the surface (mm)');

geod_rel_b1 = (all_eucl-all_geod_b1)./all_eucl;
geod_rel_b2 = (all_eucl-all_geod_b2)./all_eucl;
figure(6);
hist(geod_rel_b1(abs(geod_rel_b1)<=0.2), 80);
set(gca, 'xlim', [-0.2 0.2], 'fontsize', 16, 'linewidth', 2);
%xlabel('Relative error');

figure(7);
hist(geod_rel_b2(abs(geod_rel_b2)<=0.0012), 80);
set(gca, 'xlim', [-0.0012 0.0012], 'fontsize', 16, 'linewidth', 2, 'xtick', [-0.001 -0.0005 0 0.0005 0.001], 'XTickLabel', {'-0.001','-0.0005','0','0.0005','0.001'});
%xlabel('Relative error');


fprintf('GEODESICS ------------------------------------------------------ \n')

disp('mean')
disp(mean(geod_rel_b1))
disp(mean(geod_rel_b2))
disp(mean(geod_rel_b1./geod_rel_b2))

disp('std')
disp(std(geod_rel_b1))
disp(std(geod_rel_b2))
disp(std(geod_rel_b1./geod_rel_b2))

disp('median')
disp(median(geod_rel_b1))
disp(median(geod_rel_b2))
disp(median(geod_rel_b1./geod_rel_b2))

disp('min')
disp(min(geod_rel_b1))
disp(min(geod_rel_b2))
disp(min(geod_rel_b1./geod_rel_b2))

disp('max')
disp(max(geod_rel_b1))
disp(max(geod_rel_b2))
disp(max(geod_rel_b1./geod_rel_b2))




fprintf('CURVATURE ------------------------------------------------------ \n')

disp('mean')
disp(mean(abs(all_curv_b1)))
disp(mean(abs(all_curv_b2)))
disp(mean(abs(all_curv_b1./all_curv_b2)))

disp('std')
disp(std(abs(all_curv_b1)))
disp(std(abs(all_curv_b2)))
disp(std(abs(all_curv_b1./all_curv_b2)))

disp('median')
disp(median(abs(all_curv_b1)))
disp(median(abs(all_curv_b2)))
disp(median(abs(all_curv_b1./all_curv_b2)))

disp('min')
disp(min(abs(all_curv_b1)))
disp(min(abs(all_curv_b2)))
disp(min(abs(all_curv_b1./all_curv_b2)))

disp('max')
disp(max(abs(all_curv_b1)))
disp(max(abs(all_curv_b2)))
disp(max(abs(all_curv_b1./all_curv_b2)))


