function expe_param_noise_disp
%EXPE_PARAM_NOISE_DISP Display the results obtained with the function
%"expe_param_noise".
%
% (c)2010, Florent Brunet

% RIS is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
% 
% RIS is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
% or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
% for more details.
% 
% You should have received a copy of the GNU General Public License along
% with this program; if not, write to the Free Software Foundation, Inc.,
% 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

display_mean
%display_each_one

function display_mean
close all;

mean_r1 = zeros(11);
mean_r2 = zeros(11);

%all_i_surf = 1:38;
all_i_surf = [1 5 8 9 10 12 16 17 18 19 20 22 29 33 34 35];
k = 1;
for i_surf = all_i_surf
    for i_corresp = 1
        path = sprintf('expe_param_noise/surf%d-corresp%d.mat', i_surf, i_corresp);
        load(path);
        
        mean_r1 = mean_r1 + all_err_r1;
        mean_r2 = mean_r2 + all_err_r2;
        
        all_r1(:,:,k) = all_err_r1;
        all_r2(:,:,k) = all_err_r2;
        k = k + 1;
    end
end
mean_r1 = mean_r1 / numel(all_i_surf);
mean_r2 = mean_r2 / numel(all_i_surf);

figure(1);
[x, y] = meshgrid(all_perc);

subplot(1, 2, 1);
mesh(x, y, mean_r1);
xlabel('noise image');
ylabel('noise template');
daspect([1 1 1]);
view(0, 90);



% Min (R1)
subplot(1, 2, 1);
hold on;
ind_i = 1;
ind_j = 1;
lemin = inf;
all_min = [];
for i = 1:size(mean_r1,1)
    [m ind] = min(mean_r1(i,:));
    if m < lemin
        lemin = m;
        ind_i = i;
        ind_j = ind;
    end
    plot3(x(i,ind), y(i,ind), mean_r1(i,ind), 'r*');
    all_min = [all_min mean_r1(i,ind)];
end
plot3(x(ind_i,ind_j), y(ind_i,ind_j), mean_r1(ind_i,ind_j), 'ko');
figure(2);
plot(all_min);

figure(1);
subplot(1, 2, 2);
mesh(x, y, mean_r2); 
xlabel('noise image');
ylabel('noise template');
daspect([1 1 1]);
view(0, 90);


figure(2);
mesh(x, y, mean_r1, 'linewidth', 2); 
set(gca, 'fontsize', 16);
hold on;
%mesh(x, y, mean_r1 + std(all_r1,[],3), 'facecolor', 'none', 'edgecolor', 'k', 'linewidth', 1); 
%mesh(x, y, mean_r1 - std(all_r1,[],3), 'facecolor', 'none', 'edgecolor', 'k', 'linewidth', 1);
xlabel('Noise image');
ylabel('Noise template');
zlabel('Average error (mm)')
daspect([1 1 0.5]);
view(55, 45);
set(gca, 'fontsize', 14, 'linewidth', 2, 'xlim', [0 180], 'ylim', [0 180], 'zlim', [0 65], 'xtick', 0:60:180, 'ytick', 0:60:180, 'ztick', [0 32 64], 'projection', 'perspective');


figure(3)
contour(x, y, mean_r1, linspace(3.5,60,30), 'linewidth', 2);
daspect([1 1 1]);
set(gca, 'xtick', 0:60:180, 'ytick', 0:60:180, 'linewidth', 2, 'fontsize', 14);

function display_each_one 
close all;

for i_surf = 1:38
    for i_corresp = 1
        path = sprintf('expe_param_noise/surf%d-corresp%d.mat', i_surf, i_corresp);
        load(path);

        figure(1);
        [x, y] = meshgrid(all_perc);
        
        subplot(1, 2, 1);
        mesh(x, y, all_err_r1); %#ok<NODEF>
        xlabel('noise image');
        ylabel('noise template');
        daspect([1 1 1]);
        view(0, 90);
        
        subplot(1, 2, 2);
        mesh(x, y, all_err_r2); %#ok<NODEF>
        xlabel('noise image');
        ylabel('noise template');
        daspect([1 1 1]);
        view(0, 90);
        
        % Min (R1)
        subplot(1, 2, 1);
        hold on;
        ind_i = 1;
        ind_j = 1;
        lemin = inf;
        all_min = [];
        for i = 1:size(all_err_r1,1)
            [m ind] = min(all_err_r1(i,:));
            if m < lemin
                lemin = m;
                ind_i = i;
                ind_j = ind;
            end
            plot3(x(i,ind), y(i,ind), all_err_r1(i,ind), 'r*');
            all_min = [all_min all_err_r1(i,ind)];
        end
        plot3(x(ind_i,ind_j), y(ind_i,ind_j), all_err_r1(ind_i,ind_j), 'ko');
        %figure(2);
        %plot(all_min);
        
        % Min (R2)
        figure(1);
        subplot(1, 2, 2);
        hold on;
        ind_i = 1;
        ind_j = 1;
        lemin = inf;
        for i = 1:size(all_err_r2,1)
            [m ind] = min(all_err_r2(i,:));
            if m < lemin
                lemin = m;
                ind_i = i;
                ind_j = ind;
            end
            plot3(x(i,ind), y(i,ind), all_err_r2(i,ind), 'r*');
        end
        plot3(x(ind_i,ind_j), y(ind_i,ind_j), all_err_r2(ind_i,ind_j), 'ko');
        title(sprintf('%d',i_surf));
        pause
        close all
    end
end