function generate_lots_of_paper
%GENERATE_LOTS_OF_PAPER Generates a lot of paper foil for the experiments
%with the RIS toolbox.
%
% DESCRIPTION
%  This is just a pre-computation in order to increase the speed of the
%  experiments.
%
% (c)2010, Florent Brunet

% RIS is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
% 
% RIS is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
% or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
% for more details.
% 
% You should have received a copy of the GNU General Public License along
% with this program; if not, write to the Free Software Foundation, Inc.,
% 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

close all;

sz_grid = 100;

folder_out = 'data_paper_100';

% General experiment parameters
PAPER_MIN = 1001;
PAPER_MAX = 5000;


for i_paper = PAPER_MIN:PAPER_MAX
    fprintf('paper %d\n', i_paper);
    
    rand('twister', i_paper); %#ok<RAND>
    randn('state', i_paper); %#ok<RAND>

    % Generate a random piece of paper (without auto-occultations)
    [grid_2d_tpl grid_2d_img grid_3d cam_mat] = ris_rand_paper(sz_grid, true); %#ok<NASGU>
    
    path_out = sprintf('%s/paper%04d.mat', folder_out, i_paper);
    save(path_out, 'grid_2d_tpl', 'grid_2d_img', 'grid_3d', 'cam_mat', 'sz_grid');
end
