function [x y z] = ris_vect_to_coord(v)
%RIS_VECT_TO_COORD Explodes a vector into 3 coordinates vector for all the
%Salzmann-related code of RIS.
%
% (c)Florent Brunet.

% RIS is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
% 
% RIS is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
% or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
% for more details.
% 
% You should have received a copy of the GNU General Public License along
% with this program; if not, write to the Free Software Foundation, Inc.,
% 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

n3 = numel(v);

if mod(n3,3) ~= 0
    error('ris_vect_to_coord:size_vect', 'The size of "v" must be a multiple of 3');
end

n = n3 / 3;

tmp = reshape(v, 3, n);

x = tmp(1, :);
y = tmp(2, :);
z = tmp(3, :);
