function test_gauss_seidel
%TEST_GAUSS_SEIDEL Test of the "ris_test_gauss_seidel" function
%
% (c)2010, Florent Brunet

% RIS is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
% 
% RIS is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
% or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
% for more details.
% 
% You should have received a copy of the GNU General Public License along
% with this program; if not, write to the Free Software Foundation, Inc.,
% 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

%rand('twister', 1); %#ok<RAND>

n = 30;
A = rand(n);
b = rand(n,1);

A = A'*A;

s = svd(A);
if s(end) < 1.0e-6
    error('A is not "sufficiently" positive definite');
end

x_ref = inv(A) * b;

x = zeros(n,1);
%x = ris_test_gauss_seidel(A, x, b);
x = ris_test_SOR(A, x, b, 1.5);

[x_ref x]
disp(norm(x_ref-x))