function test_gen_paper_learning

% RIS is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
% 
% RIS is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
% or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
% for more details.
% 
% You should have received a copy of the GNU General Public License along
% with this program; if not, write to the Free Software Foundation, Inc.,
% 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

% simple_test
test_pca

function test_pca
NDATA = 400;

X = [];
Y = [];
Z = [];
for i = 1:NDATA
    disp(i);
    
    % compute the paper
    paper = randPaper;

    % evaluate the 3D mesh
    mesh3D = paperMesh(paper,5,5);

    mesh3D = centralize(mesh3D);
    
    x = vect(mesh3D(:,:,1));
    y = vect(mesh3D(:,:,2));
    z = vect(mesh3D(:,:,3));
    
    X = [X ; x'];
    Y = [Y ; y'];
    Z = [Z ; z'];
end

[COEFF_x,SCORE,latent] = princomp(X);
[COEFF_y,SCORE] = princomp(Y);
[COEFF_z,SCORE] = princomp(Z);

figure(1);
hold off
for i = 1:25
    x = COEFF_x(:,i);
    y = COEFF_y(:,i);
    z = COEFF_z(:,i);
    plot3(x, y, z, '.')
    daspect([1 1 1]);
    pause
end

function simple_test %#ok<DEFNU>
% compute the paper
paper = randPaper;

% evaluate the 3D mesh
mesh3D = paperMesh(paper,5);

x = vect(mesh3D(:,:,1));
y = vect(mesh3D(:,:,2));
z = vect(mesh3D(:,:,3));

close all

figure(1);
mesh(mesh3D(:,:,1), mesh3D(:,:,2), mesh3D(:,:,3), 'facecolor', 'none');
hold on;
plot3(x, y, z, 'k.');
daspect([1 1 1])

[mesh3D x y z] = centralize(mesh3D);
figure(2);
mesh(mesh3D(:,:,1), mesh3D(:,:,2), mesh3D(:,:,3), 'facecolor', 'none');
hold on;
plot3(x, y, z, 'k.');
daspect([1 1 1])

function [n_mesh3D nx ny nz] = centralize(mesh3D)
nx = mesh3D(:,:,1);
ny = mesh3D(:,:,2);
nz = mesh3D(:,:,3);

nx = nx - mean(nx(:));
ny = ny - mean(ny(:));
nz = nz - mean(nz(:));

n_mesh3D(:,:,1) = nx;
n_mesh3D(:,:,2) = ny;
n_mesh3D(:,:,3) = nz;
