function video_data_vincent2
%VIDEO_DATA_VINCENT2 Makes a video from the data of Vincent (the usual "tag"
%with self-occlusion).
%
% (c)2010, Florent Brunet

% RIS is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
% 
% RIS is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
% or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
% for more details.
% 
% You should have received a copy of the GNU General Public License along
% with this program; if not, write to the Free Software Foundation, Inc.,
% 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

%undist_template
%nice_corresp(50)

close all

IMG_MIN = 1;
IMG_MAX = 217;

%for i_img = 131:5:217
for i_img = IMG_MIN:IMG_MAX
    disp(i_img);
    
    %[corresp_2d_tpl corresp_2d_img tpl img cam_mat] = get_data(i_img, 0.1);
    [corresp_2d_tpl corresp_2d_img tpl img cam_mat] = get_data_fast(i_img);

    path = sprintf('data_vincent/florent8/img%03d.mat', i_img);
    save(path, 'corresp_2d_tpl', 'corresp_2d_img', 'tpl', 'img', 'cam_mat');
    %%{
%     figure(1);
%     imshow(tpl);
%     hold on;
%     plot(corresp_2d_tpl(1,:), corresp_2d_tpl(2,:), '.');
%     hold off;
% 
%     figure(2);
%     imshow(img);
%     hold on;
%     plot(corresp_2d_img(1,:), corresp_2d_img(2,:), '.');
%     hold off;
    
%    corTerm = 1;

%     [depth,linkTo,bounds3D,linkAngle] = ...
%         ris_perriollat_bounding( ...
%             corresp_2d_tpl, ...
%             corresp_2d_img, ...
%             cam_mat, ...
%             corTerm);


     %% (R1) Richard
%     pts_3d_r1 = ris_richard_errimg( ...
%       corresp_2d_tpl, corresp_2d_img, cam_mat, 0.4, 0.6);
%     pts_3d = pts_3d_r1;
    
%     figure(3);
%     plot3(pts_3d(1,:), pts_3d(2,:), pts_3d(3,:), '.');
%     daspect([1 1 1]);
%     set(gca, 'zdir', 'reverse', 'xlim', [-225 200], 'ylim', [-200 150], 'zlim', [750 1000]);
%     view(30, 30);
%     axis off;
%     set(gcf, 'color', [0 0 0]);
    

% %% (B1) B-spline fitted to R1
%      tmp = load(sprintf('video_vincent/r1/%03d.mat', i_img));
%      pts_3d_r1 = tmp.pts_3d;
%      
%     EPS = 1.0e-3;
%     n_ctrlpts = 14;
%     umin = min(corresp_2d_tpl(1,:)) - EPS;
%     umax = max(corresp_2d_tpl(1,:)) + EPS;
%     nptsu = n_ctrlpts;
%     vmin = min(corresp_2d_tpl(2,:)) - EPS;
%     vmax = max(corresp_2d_tpl(2,:)) + EPS;
%     nptsv = n_ctrlpts;
%     bbs = bbs_create(umin, umax, nptsu, vmin, vmax, nptsv, 3);
% 
%     colmat = bbs_coloc(bbs, corresp_2d_tpl(1,:), corresp_2d_tpl(2,:));
%     lbds = 0.1*ones(nptsv-3, nptsu-3);
%     bendmat = bbs_bending(bbs, lbds);
% 
%     ctrlpts = (colmat'*colmat + bendmat) \ (colmat' * pts_3d_r1');
%     ctrlpts = ctrlpts';
% % 
% %     % Display the initial B-spline
% %     figure(5);
% %     dnu = 7*2+1;
% %     dnv = 9*2+1;
% %     [du,dv] = meshgrid(linspace(umin,umax,dnu), linspace(vmin,vmax,dnv));
% %     pts_3d_b1 = bbs_eval(bbs, ctrlpts, du, dv);
% %     mesh(reshape(pts_3d_b1(1,:), dnv, dnu), ...
% %          reshape(pts_3d_b1(2,:), dnv, dnu), ...
% %          reshape(pts_3d_b1(3,:), dnv, dnu), ...
% %          'facecolor', 'none', 'edgecolor', ones(1,3), 'linewidth', 2);
% %     daspect([1 1 1]);
% %     axis off;
% %     set(gca, 'zdir', 'reverse', 'xlim', [-225 200], 'ylim', [-200 150], 'zlim', [750 1000]);
% %     view(30,30);
% %     set(gcf, 'color', [0 0 0]);
%   
%     %% (B2) Refined B-spline
% 
%     % Initial parameters
%     if i_img == IMG_MIN
%         tmp = load(sprintf('video_vincent/b1/%03d.mat', i_img));
%         pts_3d_b1 = bbs_eval(tmp.bbs, tmp.ctrlpts, corresp_2d_tpl(1,:), corresp_2d_tpl(2,:));
%         param_init = [vect(sqrt(sum(pts_3d_b1.^2))) ; vect(ctrlpts')];
%     else
%         pts_3d_b1 = bbs_eval(bbs, prev_ctrlpts_b2, corresp_2d_tpl(1,:), corresp_2d_tpl(2,:));
%         param_init = [vect(sqrt(sum(pts_3d_b1.^2))) ; vect(prev_ctrlpts_b2')];
%     end
% 
%     % Optimization
%     ctrlpts_b2 = ris_jacob_inext_depth_jacob( ...
%          corresp_2d_tpl, corresp_2d_img, cam_mat, bbs, param_init, 31, 10, 10);
%     %save('ctrlpts_b2.mat', 'ctrlpts_b2');
%     prev_ctrlpts_b2 = ctrlpts_b2;
% 
% 
%     % Display the refined B-spline
%     figure(7);
%     dnu = 7*2+1;
%     dnv = 9*2+1;
%     [du,dv] = meshgrid(linspace(umin,umax,dnu), linspace(vmin,vmax,dnv));
%     pts_3d_b2 = bbs_eval(bbs, ctrlpts_b2, du, dv);
%     mesh(reshape(pts_3d_b2(1,:), dnv, dnu), ...
%          reshape(pts_3d_b2(2,:), dnv, dnu), ...
%          reshape(pts_3d_b2(3,:), dnv, dnu), ...
%          'facecolor', 'none', 'edgecolor', ones(1,3), 'linewidth', 2);
%     daspect([1 1 1]);
%     axis off;
%     set(gca, 'zdir', 'reverse', 'xlim', [-225 200], 'ylim', [-200 150], 'zlim', [750 1000]);
%     view(30,30);
%     set(gcf, 'color', [0 0 0]);
    
    
    
    
    
    
    %% Salzmann's method
    EPS = 1.0e-3;
    umin = min(corresp_2d_tpl(1,:)) - EPS;
    umax = max(corresp_2d_tpl(1,:)) + EPS;
    vmin = min(corresp_2d_tpl(2,:)) - EPS;
    vmax = max(corresp_2d_tpl(2,:)) + EPS;

    % Initialization for the Salzmann's method
    n_corresp = size(corresp_2d_tpl,2);
    npts_mesh = 10;
    [tri tri_x tri_y tri_z] = ris_create_tri_mesh(umin, umax, npts_mesh, vmin, vmax, npts_mesh);

    % Convert the template points into barycentric coordinates
    [b1 b2 b3 ind_tri] = ris_cart_to_bary( ...
        tri, tri_x, tri_y, tri_z, ... 
        corresp_2d_tpl(1,:), corresp_2d_tpl(2,:), ones(size(corresp_2d_tpl(2,:))));

    % Build the inextensibility pairs
    thres_dist = 1.25 * sqrt(2*(max(umax-umin, vmax-vmin) / (npts_mesh - 1))^2);
    [inext_pairs dist_pairs] = ris_make_inext_pairs(tri_x, tri_y, thres_dist);

    % Reconstruction
    % (x,y,z) are the Cartesian coordinates of the mesh _vertices_
    [~, x, y, z] = ris_salzmann_err( ...
                            tri, npts_mesh^2, ...
                            ind_tri, b1, b2, b3, ...
                            corresp_2d_img, ...
                            cam_mat, ...
                            inext_pairs, dist_pairs, ...
                            ones(1,n_corresp), 5);

    % Display the Salzmann's mesh
    figure(10);
    trimesh(tri, x, y, z, 'facecolor', 'none', 'edgecolor', ones(1,3), 'linewidth', 2);
    daspect([1 1 1]);
    axis off;
    set(gca, 'zdir', 'reverse', 'xlim', [-225 200], 'ylim', [-200 150], 'zlim', [750 1000]);
    view(30,30);
    set(gcf, 'color', [0 0 0]);

    
    
    pause(0.1);
    
    F = getframe;
    
    
%     save(sprintf('video_vincent/b2pp/%03d.mat', i_img), 'bbs', 'ctrlpts_b2');
%     imwrite(F.cdata, sprintf('video_vincent/b2pp/%03d.png', i_img));
    save(sprintf('video_vincent/s/%03d.mat', i_img), 'tri', 'x', 'y', 'z');
    imwrite(F.cdata, sprintf('video_vincent/s/%03d.png', i_img));

    %%}
end

function [corresp_2d_tpl corresp_2d_img tpl img cam_mat] = get_data_fast(i_img)
    path = sprintf('data_vincent/florent8/img%03d.mat', i_img);
    load(path);
    
function [corresp_tpl corresp_img tpl img cam_mat] = get_data(i_img, thres)

load data_vincent/Nmesh.mat

szn = 105;
szm = 126;

pts = reshape(Nmesh(1,:), szn, szm, 2); %#ok<NODEF>
corresp_img1 = [vect(pts(:,:,1))' ; vect(pts(:,:,2))'];
load('data_vincent/paperSelfOcclusionsData/templatePSO.mat');
tpl = imTemplate;
tmp = HfromImageToTemplate * [corresp_img1 ; ones(1, size(corresp_img1,2))];
corresp_tpl = tmp(1:2,:) ./ repmat(tmp(3,:), 2, 1);

pts = reshape(Nmesh(i_img,:), szn, szm, 2);
corresp_img = [vect(pts(:,:,1))' ; vect(pts(:,:,2))'];
img = imread(sprintf('data_vincent/video/%08d.png', i_img));


umin = floor(min(corresp_tpl(1,:)));
umax = ceil(max(corresp_tpl(1,:)));
vmin = floor(min(corresp_tpl(2,:)));
vmax = ceil(max(corresp_tpl(2,:)));
nptsu = 64;
nptsv = round(nptsu/1.21);


bbs = bbs_create(umin, umax, nptsu, vmin, vmax, nptsv, 2);

colmat = bbs_coloc(bbs, corresp_tpl(1,:)', corresp_tpl(2,:)');
lbds = 0.01*ones(nptsv-3, nptsu-3);
bendmat = bbs_bending(bbs, lbds);

ctrlpts = (colmat'*colmat + bendmat) \ (colmat' * corresp_img');
ctrlpts = ctrlpts';


[gu gv] = meshgrid(umin:umax, vmin:vmax);
tmp = bbs_eval(bbs, ctrlpts, gu, gv, 1, 0);
gx_du = reshape(tmp(1,:), numel(vmin:vmax), numel(umin:umax));
gy_du = reshape(tmp(2,:), numel(vmin:vmax), numel(umin:umax));

tmp = bbs_eval(bbs, ctrlpts, gu, gv, 0, 1);
gx_dv = reshape(tmp(1,:), numel(vmin:vmax), numel(umin:umax));
gy_dv = reshape(tmp(2,:), numel(vmin:vmax), numel(umin:umax));

map_vinc = zeros(size(gx_du));
for iv = 1:numel(vmin:vmax)
    for iu = 1:numel(umin:umax)
        J = [gx_du(iv,iu) gx_dv(iv,iu) ; gy_du(iv,iu) gy_dv(iv,iu)];
        O = J'*J;
        map_vinc(iv,iu) = (O(1,1) + O(2,2) - sqrt((O(1,1)-O(2,2))^2 + 4*O(1,2)^2))/2;
    end
end


map_occl = map_vinc<thres;

tpl_u = reshape(corresp_tpl(1,:), szn, szm);
tpl_v = reshape(corresp_tpl(2,:), szn, szm);
img_x = reshape(corresp_img(1,:), szn, szm);
img_y = reshape(corresp_img(2,:), szn, szm);

indu = unique([1:8:105 105]);
indv = unique([1:8:126 126]);

cu = vect(tpl_u(indu, indv))';
cv = vect(tpl_v(indu, indv))';
cx = vect(img_x(indu, indv))';
cy = vect(img_y(indu, indv))';


occl = interp2(double(map_occl), cu, cv, 'nearest');
ind = find(occl <= 0.5);

corresp_tpl = [cu(ind);cv(ind)];
corresp_img = [cx(ind);cy(ind)];

load('data_vincent/paperSelfOcclusionsData/camera.mat');
cam_mat = camera;



