function video_data_vincent2_texture
% RIS is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
% 
% RIS is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
% or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
% for more details.
% 
% You should have received a copy of the GNU General Public License along
% with this program; if not, write to the Free Software Foundation, Inc.,
% 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

close all;

i_img = 1;

[corresp_2d_tpl corresp_2d_img tpl img cam_mat] = get_data_fast(i_img);

tpl = mat2gray(tpl);
texturemap(:,:,1) = flipud(tpl(:,:,1));
texturemap(:,:,2) = flipud(tpl(:,:,2));
texturemap(:,:,3) = flipud(tpl(:,:,3));

IMG_MIN = 1;
IMG_MAX = 217;

for i_img = IMG_MIN:IMG_MAX
    disp(i_img);
  
    %load(sprintf('video_vincent/b2pp/%03d.mat', i_img));
    load(sprintf('video_vincent/b1/%03d.mat', i_img));
%{
    figure(1);
    dnu = size(tpl,2);
    dnv = size(tpl,1);
    [du,dv] = meshgrid(linspace(bbs.umin,bbs.umax,dnu), linspace(bbs.vmin,bbs.vmax,dnv));
    pts_3d_b1 = bbs_eval(bbs, ctrlpts, du, dv);
    mesh(reshape(pts_3d_b1(1,:), dnv, dnu), ...
         reshape(pts_3d_b1(2,:), dnv, dnu), ...
         reshape(pts_3d_b1(3,:), dnv, dnu), ...
         'FaceColor', 'texturemap', 'CData', texturemap);
    daspect([1 1 1]);
    axis off;
    set(gca, 'zdir', 'reverse', 'xlim', [-225 200], 'ylim', [-200 150], 'zlim', [750 1000]);
    view(30,30);
    set(gcf, 'color', [0 0 0]);
    
     
    pause(0.5);
    
    F = getframe;
    
    imwrite(F.cdata, sprintf('video_vincent/text_b1/%03d.png', i_img));

    
    close all
    pause(0.5);
    %}
    
    [corresp_2d_tpl corresp_2d_img tpl img cam_mat] = get_data_fast(i_img);
    
    EPS = 1.0e-3;
    umin = min(corresp_2d_tpl(1,:)) - EPS;
    umax = max(corresp_2d_tpl(1,:)) + EPS;
    vmin = min(corresp_2d_tpl(2,:)) - EPS;
    vmax = max(corresp_2d_tpl(2,:)) + EPS;
    
    % Initialization for the Salzmann's method

    npts_mesh = 10;
    [tri tri_x tri_y tri_z] = ris_create_tri_mesh(umin, umax, npts_mesh, vmin, vmax, npts_mesh);

    % Convert the template points into barycentric coordinates
    dnu = size(tpl,2);
    dnv = size(tpl,1);
    [du,dv] = meshgrid(linspace(bbs.umin,bbs.umax,dnu), linspace(bbs.vmin,bbs.vmax,dnv));
%     [b1 b2 b3 ind_tri] = ris_cart_to_bary( ...
%         tri, tri_x, tri_y, tri_z, ... 
%         du(:), dv(:), ones(size(du(:))));
%    save('bary.mat', 'b1', 'b2', 'b3', 'ind_tri');
    load('bary.mat');
    
    load(sprintf('video_vincent/s/%03d.mat', i_img));
    
    % Reprojects the mesh in the image
    figure(1);
    [xx yy zz] = bary_to_cart(tri, x, y, z, ind_tri, b1, b2, b3);
    
    
    mesh(reshape(xx, dnv, dnu), ...
         reshape(yy, dnv, dnu), ...
         reshape(zz, dnv, dnu), ...
         'FaceColor', 'texturemap', 'CData', texturemap);
    daspect([1 1 1]);
    axis off;
    set(gca, 'zdir', 'reverse', 'xlim', [-225 200], 'ylim', [-200 150], 'zlim', [750 1000]);
    view(30,30);
    set(gcf, 'color', [0 0 0]);
    
    pause(1);
    
    F = getframe;
    
    imwrite(F.cdata, sprintf('video_vincent/text_s/%03d.png', i_img));

    
    close all
    pause(0.5);
end


function [corresp_2d_tpl corresp_2d_img tpl img cam_mat] = get_data_fast(i_img)
    path = sprintf('data_vincent/florent8/img%03d.mat', i_img);
    load(path);
    
function [x y z] = bary_to_cart(tri, tx, ty, tz, ind_tri, b1, b2, b3)
x = zeros(size(b1));
y = zeros(size(b1));
z = zeros(size(b1));
% Evaluate the 3D position of the data points
for i = 1:numel(b1)
%     if mod(i, 1000) == 0
%         disp(i)
%     end
    i1 = tri(ind_tri(i), 1);
    i2 = tri(ind_tri(i), 2);
    i3 = tri(ind_tri(i), 3);
    x(i) = b1(i) * tx(i1) + b2(i) * tx(i2) + b3(i) * tx(i3); 
    y(i) = b1(i) * ty(i1) + b2(i) * ty(i2) + b3(i) * ty(i3); 
    z(i) = b1(i) * tz(i1) + b2(i) * tz(i2) + b3(i) * tz(i3); 
end