function video_data_vincent_bak
%VIDEO_DATA_VINCENT_BAK All sort of crap removed from the initial file
%"video_data_vincent"

% RIS is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
% 
% RIS is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
% or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
% for more details.
% 
% You should have received a copy of the GNU General Public License along
% with this program; if not, write to the Free Software Foundation, Inc.,
% 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

function nice_corresp(i_img)
close all



load data_vincent/Nmesh.mat

szn = 105;
szm = 126;


pts = reshape(Nmesh(1,:), szn, szm, 2);
corresp_img1 = [vect(pts(:,:,1))' ; vect(pts(:,:,2))'];
load('data_vincent/paperSelfOcclusionsData/templatePSO.mat');
tpl = imTemplate;
tmp = HfromImageToTemplate * [corresp_img1 ; ones(1, size(corresp_img1,2))];
corresp_tpl = tmp(1:2,:) ./ repmat(tmp(3,:), 2, 1);


pts = reshape(Nmesh(i_img,:), szn, szm, 2);
corresp_img = [vect(pts(:,:,1))' ; vect(pts(:,:,2))'];
img = imread(sprintf('data_vincent/video/%08d.png', i_img));




figure(1);
imshow(tpl);
hold on;
plot(corresp_tpl(1,:), corresp_tpl(2,:), '.');

figure(2);
imshow(img);
hold on;
plot(corresp_img(1,:), corresp_img(2,:), '.');





umin = floor(min(corresp_tpl(1,:)));
umax = ceil(max(corresp_tpl(1,:)));
vmin = floor(min(corresp_tpl(2,:)));
vmax = ceil(max(corresp_tpl(2,:)));
nptsu = 64;
nptsv = round(nptsu/1.21);


bbs = bbs_create(umin, umax, nptsu, vmin, vmax, nptsv, 2);

colmat = bbs_coloc(bbs, corresp_tpl(1,:)', corresp_tpl(2,:)');
lbds = 0.01*ones(nptsv-3, nptsu-3);
bendmat = bbs_bending(bbs, lbds);

ctrlpts = (colmat'*colmat + bendmat) \ (colmat' * corresp_img');
ctrlpts = ctrlpts';

dnu = 30;
dnv = round(dnu/1.21);
[du dv] = meshgrid(linspace(umin,umax,dnu), linspace(vmin,vmax,dnv));
tmp = bbs_eval(bbs, ctrlpts, du, dv);
dx = reshape(tmp(1,:), dnv, dnu);
dy = reshape(tmp(2,:), dnv, dnu);

figure(2);
hold on;
mesh(dx, dy, zeros(size(dx)), 'facecolor', 'none', 'edgecolor', 'k');
view(0,90);
daspect([1 1 1])



[gu gv] = meshgrid(umin:umax, vmin:vmax);
tmp = bbs_eval(bbs, ctrlpts, gu, gv, 1, 0);
gx_du = reshape(tmp(1,:), numel(vmin:vmax), numel(umin:umax));
gy_du = reshape(tmp(2,:), numel(vmin:vmax), numel(umin:umax));

tmp = bbs_eval(bbs, ctrlpts, gu, gv, 0, 1);
gx_dv = reshape(tmp(1,:), numel(vmin:vmax), numel(umin:umax));
gy_dv = reshape(tmp(2,:), numel(vmin:vmax), numel(umin:umax));

amp_grad = sqrt(gx_du.^2 + gy_du.^2) + sqrt(gx_dv.^2 + gy_dv.^2);
map_vinc = zeros(size(gx_du));
for iv = 1:numel(vmin:vmax)
    for iu = 1:numel(umin:umax)
        J = [gx_du(iv,iu) gx_dv(iv,iu) ; gy_du(iv,iu) gy_dv(iv,iu)];
        O = J'*J;
        map_vinc(iv,iu) = (O(1,1) + O(2,2) - sqrt((O(1,1)-O(2,2))^2 + 4*O(1,2)^2))/2;
    end
end

figure(3);
imagesc(amp_grad);
daspect([1 1 1]);

figure(30);
imagesc(map_vinc);
daspect([1 1 1]);

amp_grad = map_vinc;

figure(4);
thres = 0.4;
figure(4);
map_occl = amp_grad<thres;
imshow(map_occl);


figure(5);
tpl_r = tpl(:,:,1);
tpl_g = tpl(:,:,2);
tpl_b = tpl(:,:,3);
tpl_r(amp_grad<thres) = 0;
tpl_g(amp_grad<thres) = 0;
tpl_b(amp_grad<thres) = 0;
tplo(:,:,1) = tpl_r;
tplo(:,:,2) = tpl_g;
tplo(:,:,3) = tpl_b;
imshow(tplo);

figure(6);
imshow(tpl);


tpl_u = reshape(corresp_tpl(1,:), szn, szm);
tpl_v = reshape(corresp_tpl(2,:), szn, szm);
img_x = reshape(corresp_img(1,:), szn, szm);
img_y = reshape(corresp_img(2,:), szn, szm);

indu = 1:8:105;
indv = [1:8:126 126];

cu = vect(tpl_u(indu, indv))';
cv = vect(tpl_v(indu, indv))';
cx = vect(img_x(indu, indv))';
cy = vect(img_y(indu, indv))';


occl = interp2(double(map_occl), cu, cv, 'nearest');
ind = find(occl <= 0.5);

cu = cu(ind);
cv = cv(ind);
cx = cx(ind);
cy = cy(ind);

figure(1);
plot(cu, cv, 'r*');

figure(2);
plot(cx, cy, 'r*');


figure(7);
imshow(img);

figure(5);


function show_data
close all

IMG_MIN = 130;
IMG_MAX = 217;

thres = 7;

for i_img = IMG_MIN:IMG_MAX
    [corresp_2d_tpl corresp_2d_img tpl img cam_mat] = load_data(i_img);

    figure(1);
    imshow(tpl);
    hold on;
    plot(corresp_2d_tpl(1,:), corresp_2d_tpl(2,:), '.');
    

    figure(2);
    imshow(img);
    hold on;
    plot(corresp_2d_img(1,:), corresp_2d_img(2,:), '.');
    
    
    dst = squareform(pdist(corresp_2d_img'));
    ind = find(sum(abs(dst)<thres)<2);
    
    figure(1);
    plot(corresp_2d_tpl(1,ind), corresp_2d_tpl(2,ind), 'ro');
    hold off;
    
    figure(2);
    plot(corresp_2d_img(1,ind), corresp_2d_img(2,ind), 'ro');
    hold off;
    
    pause
end



function [corresp_2d_tpl corresp_2d_img tpl img cam_mat] = load_data(i_img)

load('data_vincent/mesh.mat');

corresp = reshape(a(i_img,:), 15, 18, 2);
corresp_2d_img = [vect(corresp(:,:,1))' ; vect(corresp(:,:,2))'];
path_img = sprintf('data_vincent/video/%08d.png', i_img);
img = imread(path_img);


load('data_vincent/paperSelfOcclusionsData/templatePSO.mat');

tpl = imTemplate;

stepMesh=20;
sizeImgTexture = size(imTemplate);
xMesh=fix(linspace(1,sizeImgTexture(2),sizeImgTexture(2)/stepMesh));
yMesh=fix(linspace(1,sizeImgTexture(1),sizeImgTexture(1)/stepMesh));
[XMesh,YMesh]=meshgrid(xMesh,yMesh);
corresp_2d_tpl = [XMesh(:),YMesh(:)]';

load('data_vincent/paperSelfOcclusionsData/camera.mat');
cam_mat = camera;









function undist_template
close all;

pts_top = [
177.5506  105.8108
213.8641  106.8516
259.3696  110.3215
330.8491  115.8734
331.8735  116.5675
375.3577  116.2197
421.5659  113.7916
440.5914  112.7499
522.1336  107.1980
];

pts_bottom = [
159.7675  420.5289
244.4528  421.5699
335.6904  422.2639
441.5420  420.1819
532.7998  418.1000
];

pts_left = [
166.1500  111.0311
163.0011  179.4053
161.2018  251.8280
160.3022  340.4445
158.5028  416.4658
];
tmp = pts_left(:,1);
pts_left(:,1) = pts_left(:,2);
pts_left(:,2) = tmp;

pts_right = [
523.3879  109.0612
526.3728  178.9939
528.9313  259.1607
531.0634  332.5048
533.6219  416.5093
];
tmp = pts_right(:,1);
pts_right(:,1) = pts_right(:,2);
pts_right(:,2) = tmp;


pts = pts_top;
M = [pts(:,1).^3 pts(:,1).^2 pts(:,1) ones(size(pts(:,1)))];
c_top = M \ pts(:,2);

pts = pts_bottom;
M = [pts(:,1).^3 pts(:,1).^2 pts(:,1) ones(size(pts(:,1)))];
c_bottom = M \ pts(:,2);

pts = pts_right;
M = [pts(:,1).^3 pts(:,1).^2 pts(:,1) ones(size(pts(:,1)))];
c_right = M \ pts(:,2);

pts = pts_left;
M = [pts(:,1).^3 pts(:,1).^2 pts(:,1) ones(size(pts(:,1)))];
c_left = M \ pts(:,2);

%x = linspace(100, 420);
%y = polyval(c, x);

tpl = imread(sprintf('data_vincent/video/%08d.png', 1));

figure(1);
imshow(tpl);

ny = 10;
for i = 0:ny
    c = -i*(c_bottom-c_top)/ny + c_bottom;
    x = linspace(155, 540);
    y = polyval(c, x);
    hold on;
    plot(x, y);
end

nx = round(ny*1.21);
for i = 0:nx
    c = -i*(c_left-c_right)/nx + c_left;
    x = linspace(100, 430);
    y = polyval(c, x);
    hold on;
    plot(y, x);
end


% all_u = [];
% all_v = [];
% all_x = [];
% all_y = [];
% for iy = 0:ny
%     disp(iy);
%     c_h = -iy*(c_bottom-c_top)/ny + c_bottom;
%     for ix = 0:nx
%         c_v = -ix*(c_left-c_right)/nx + c_left;
%         opt = optimset('lsqnonlin');
%         opt = optimset(opt, 'MaxIter', 400);
%         x_init = 155+ix*(540-155)/nx;
%         y_init = 530-(100+iy*(430-100)/ny);
%         %plot(x_init, y_init, 'g.');
%         p_opt = lsqnonlin(@(param)cost(c_v, c_h, param), [x_init ; y_init], [155 ; 100], [540 ; 430], opt);
%         plot(p_opt(1), p_opt(2), 'r.');
%         
%         all_u = [all_u 1+ix*(376-1)/nx];
%         all_v = [all_v 1+iy*(336-1)/ny];
%         all_x = [all_x p_opt(1)];
%         all_y = [all_y p_opt(2)];
%     end
% end
% 
% save out.mat all_u all_v all_x all_y
load out.mat

figure(2);
plot(all_u, all_v, '.');
daspect([1 1 1]);

umin = 1;
umax = 376;
vmin = 1;
vmax = 336;
nptsu = nx;
nptsv = ny;
bbs = bbs_create(umin, umax, nptsu, vmin, vmax, nptsv, 2);
colmat = bbs_coloc(bbs, all_u, all_v);
bendmat = bbs_bending(bbs, 0.00001*ones(nptsv-3,nptsu-3));
ctrlpts = (colmat'*colmat + bendmat) \ (colmat' * [all_x' all_y']);
ctrlpts = ctrlpts';

dn = 40;
[du dv] = meshgrid(linspace(umin,umax,dn), linspace(vmin,vmax,dn));
tmp = bbs_eval(bbs, ctrlpts, du, dv);
figure(1);
mesh(reshape(tmp(1,:),dn,dn), reshape(tmp(2,:),dn,dn), 0.01*ones(dn), 'facecolor', 'none');


[u,v] = meshgrid(1:376,336:-1:1);
tmp = bbs_eval(bbs, ctrlpts, u, v);
x = reshape(tmp(1,:), 336, 376);
y = reshape(tmp(2,:), 336, 376);

ntpl_r = interp2(double(tpl(:,:,1)), x, y);
ntpl_g = interp2(double(tpl(:,:,2)), x, y);
ntpl_b = interp2(double(tpl(:,:,3)), x, y);

ntpl(:,:,1) = round(ntpl_r);
ntpl(:,:,2) = round(ntpl_g);
ntpl(:,:,3) = round(ntpl_b);
ntpl(ntpl < 0) = 0;
ntpl(ntpl > 255) = 255;
ntpl = uint8(ntpl);

figure(3);
imshow(ntpl);


% Warp inverse
umin = min(all_x);
umax = max(all_x);
vmin = min(all_y);
vmax = max(all_y);
bbs = bbs_create(umin, umax, nptsu, vmin, vmax, nptsv, 2);
colmat = bbs_coloc(bbs, all_x, all_y);
bendmat = bbs_bending(bbs, 0.00001*ones(nptsv-3,nptsu-3));
ctrlpts = (colmat'*colmat + bendmat) \ (colmat' * [all_u' all_v']);
ctrlpts = ctrlpts';


load data_vincent/Nmesh.mat

szn = 105;
szm = 126;

pts = reshape(Nmesh(1,:), szn, szm, 2);
corresp_img = [vect(pts(:,:,1))' ; vect(pts(:,:,2))'];

tmp = bbs_eval(bbs, ctrlpts, corresp_img(1,:), corresp_img(2,:));
figure(3);
hold on;
plot(tmp(1,:), tmp(2,:), '.');

figure(4);
imshow(tpl);
hold on;
plot(corresp_img(1,:), corresp_img(2,:), '.');

function val = cost(c_v, c_h, param)
x = param(1);
y = param(2);
val = [x - polyval(c_v, y) ; y - polyval(c_h, x)];
